var YohohoBarCounter = {
    prefs: null,
    counterElement: null,
    counterString: null,
    counterEndTime: "0",
    yohohoWin: null,
    interval: null,

    startup: function(){
        // Register to receive notifications of preference changes

        this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
        .getService(Components.interfaces.nsIPrefService)
        .getBranch("extensions.yohohobar.counter.");
        this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
        this.prefs.addObserver("", this, false);

        this.counterElement = document.getElementById('Yohoho-Counter');
        this.counterElement.addEventListener("command", function(e) { YohohoBarCounter.counterClick(); }, false);
        this.counterElement.addEventListener("mouseover", function(e) { YohohoBarCounter.toolTip(); }, false);

        this.counterString  = document.getElementById("YohohoCounterStrings");
        this.counterEndTime = this.prefs.getCharPref("endtime");

        this.refreshCounter();
        this.interval = setInterval(function(e) { YohohoBarCounter.refreshCounter(); }, 100);
    },

    shutdown: function(){
        this.prefs.removeObserver("", this);
    },

    observe: function(subject, topic, data)
    {
        if (topic != "nsPref:changed")
        {
            return;
        }

        switch(data)
        {
            case "endtime":
            this.counterEndTime = this.prefs.getCharPref("endtime");
            break;
        }
    },

    refreshCounter: function(){
        var jetzt = new Date();
        var endtime = new Date(parseInt(this.counterEndTime));
        var counter = ((endtime.getTime() - jetzt.getTime()) / 1000) + 1;

        if (counter > 0) {
            switch (this.prefs.getBoolPref("yohohotime")){
                case true:
                this.counterElement.label    = this.yohohoTime(counter);
                break;

                case false:
                this.counterElement.label    = this.normalZeit(counter);
                break;
            }


        }
        if (counter <= 0) {
            this.counterElement.label    = "00:00:00";
            if (this.prefs.getBoolPref("alarm")){
                this.prefs.setBoolPref("alarm", false);
                this.counterAlarm();
            }
        }
    },

    yohohoTime: function(counter){
        var tage    = Math.floor(counter / 24 / 60);
        var std    = Math.floor(counter / 60 ) - (tage * 24);
        var min     = Math.floor(counter - (tage * 24 * 60) - (std * 60));

        if(tage < 10){
            tage    = '0' + tage;
        }
        if(std < 10){
            std = '0' + std;
        }
        if(min < 10){
            min = '0' + min;
        }
        return tage + ":" + std + ":" + min;
    },

    normalZeit: function(counter){
        var std    = Math.floor(counter / 60 / 60);
        var min    = Math.floor(counter / 60 ) - (std * 60);
        var sek    = Math.floor(counter - (std * 60 * 60) - (min * 60));

        if(std < 10){
            std    = '0' + std;
        }
        if(min < 10){
            min = '0' + min;
        }
        if(sek < 10){
            sek = '0' + sek;
        }
        return std + ":" + min + ":" + sek;
    },

    counterAlarm: function(){
        var sound = Components.classes["@mozilla.org/sound;1"].createInstance(Components.interfaces.nsISound);
        sound.init();

        if(this.prefs.getBoolPref("sound.enabled")){
            if(this.prefs.getBoolPref("sound.usefile")){
                var soundfileuri = Components.classes["@mozilla.org/network/io-service;1"]
                .getService(Components.interfaces.nsIIOService)
                .newURI(this.prefs.getCharPref("soundfile"), null, null);
                sound.play(soundfileuri);
            } else {
                sound.beep();
            }
        }
        if(this.prefs.getBoolPref("info.enabled")){
            this.counterInfo();
        }
    },

    counterInfo: function(){
        alert(this.counterString.getString('arrivalInfo'));
    },

    readCounter: function(){
        if(this.searchYohoho()){
            if (this.yohohoWin.document.URL == "http://blackbeard-yohoho.de/main/landgang.php" || this.yohohoWin.document.URL == "http://blackbeard-yohoho.de/main/landgang.php?wo=hlok"){
                if (this.yohohoWin.counter_segelzeit > 0 || this.yohohoWin.counter_aktion > 0){
                    var target = new Date();
                    if (this.yohohoWin.counter_segelzeit > 0){
                        this.prefs.setCharPref("endtime", target.getTime() + parseInt(this.yohohoWin.counter_segelzeit) * 1000);
                    }
                    else{
                        this.prefs.setCharPref("endtime", target.getTime() + parseInt(this.yohohoWin.counter_aktion) * 1000);
                    }
                    this.prefs.setBoolPref("alarm", true);
                }
                else {
                    alert(this.counterString.getString('notOnSeaInfo'));
                }
            }
            else{
                alert(this.counterString.getString('noLandInfo'));
            }
        }
        else {
            alert(this.counterString.getString('noYohohoInfo'));
        }
    },

    resetCounter: function(){
        var jetzt = new Date();
        this.prefs.setCharPref("endtime", jetzt.getTime());
        this.prefs.setBoolPref("alarm", false);
    },

    counterClick: function(){
        var jetzt = new Date();
        var endtime = new Date(parseInt(this.counterEndTime));
        var counter = ((endtime.getTime() - jetzt.getTime()) / 1000) + 1;
        if (counter > 0) {
            this.resetCounter();
        }
        else {
            this.readCounter();
        }
    },

    searchYohoho: function(){
        var win = getTopWin();
        for (var i = 0; i < win.frames.length; i++){
            switch (win.frames[i].document.URL) {
                case "http://blackbeard-yohoho.de/index.php":
                this.yohohoWin = win.frames[i].haupt.mainFrame;
                break;
                case "http://blackbeard-yohoho.de/":
                this.yohohoWin = win.frames[i].haupt.mainFrame;
                break;
                case "http://blackbeard-yohoho.de/main/index.php":
                this.yohohoWin = win.frames[i].mainFrame;
                break;
                case "http://blackbeard-yohoho.de/main/":
                this.yohohoWin = win.frames[i].mainFrame;
                break;
            }
        }
        if (this.yohohoWin != null) {
            return true;
        }
        else {
            return false;
        }
    },

    toolTip: function (){
        var jetzt = new Date();
        var endtime = new Date(parseInt(this.counterEndTime));
        var counter = ((endtime.getTime() - jetzt.getTime()) / 1000) + 1;
        if (counter > 0) {
            this.counterElement.tooltipText    = this.counterString.getString('arrival') + ': ' + endtime.getHours() + ':' + endtime.getMinutes() + ' am ' + endtime.getDate() + '.' + endtime.getMonth() + '.' +  endtime.getYear();
        }
        else {
            this.counterElement.tooltipText    = this.counterString.getString('notOnSeaInfo');
        }
    }
}

window.addEventListener("load", function(e) { YohohoBarCounter.startup(); }, false);
window.addEventListener("unload", function(e) { YohohoBarCounter.shutdown(); }, false);